/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fernandez_sanchez_abraham_PROG07_Tarea;

import java.beans.PropertyVetoException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import persistencia.TrabajoClass;
import persistencia.UtilClass;

/**
 *
 * @author Abraham Fernandez Sanchez
 */
public final class WindowEditTrabajo extends javax.swing.JInternalFrame {

    UtilClass util;
    TrabajoClass trabajo;
    
    private String nombreTrabajo;
    
    /**
     * Creates new form WindowEditTrabajo
     */
    public WindowEditTrabajo() {
        initComponents();
        loadComboBoxTrabajos();
        jPanelEdicion.setVisible(false);
        this.setSize(366, 95);//diemnsiones de la ventana principal
    }
    
    /**
     * Metodo que introduce los trabajos existentes en persistencia en el JCombo box
     */
    public void loadComboBoxTrabajos(){
        util = new UtilClass();
        int size = util.sizeListaTrabajos();  
        for (int i = 0; i < size; i++) {
            nombreTrabajo = util.getTrabajo(i);
            jComboBoxTrabajos.insertItemAt(nombreTrabajo, i);            
        }            
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jComboBoxTrabajos = new javax.swing.JComboBox<>();
        jPanelEdicion = new javax.swing.JPanel();
        jTextFieldNombreTrabajo = new javax.swing.JTextField();
        jButtonGuardarModificacion = new javax.swing.JButton();
        jButtonDelete = new javax.swing.JButton();
        jButtonCancelar = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);

        jLabel1.setText("Editar o Eliminar el puesto de trabajo");

        jComboBoxTrabajos.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxTrabajosActionPerformed(evt);
            }
        });

        jButtonGuardarModificacion.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fernandez_sanchez_abraham_PROG07_Tarea/iconos/FontAwesome_f00c(3)_32.png"))); // NOI18N
        jButtonGuardarModificacion.setText("Aceptar");
        jButtonGuardarModificacion.setToolTipText("Aceptar la Edicion del puesto de trabajo");
        jButtonGuardarModificacion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonGuardarModificacionActionPerformed(evt);
            }
        });

        jButtonDelete.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fernandez_sanchez_abraham_PROG07_Tarea/iconos/FontAwesome_f014(5)_32.png"))); // NOI18N
        jButtonDelete.setText("Eliminar");
        jButtonDelete.setToolTipText("Eliminar este puesto de trabajo");
        jButtonDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDeleteActionPerformed(evt);
            }
        });

        jButtonCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fernandez_sanchez_abraham_PROG07_Tarea/iconos/FontAwesome_f00d(2)_32.png"))); // NOI18N
        jButtonCancelar.setText("Cancelar");
        jButtonCancelar.setToolTipText("Cancelacion de la edicion");
        jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelarActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelEdicionLayout = new javax.swing.GroupLayout(jPanelEdicion);
        jPanelEdicion.setLayout(jPanelEdicionLayout);
        jPanelEdicionLayout.setHorizontalGroup(
            jPanelEdicionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jTextFieldNombreTrabajo)
            .addGroup(jPanelEdicionLayout.createSequentialGroup()
                .addComponent(jButtonGuardarModificacion)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jButtonDelete)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jButtonCancelar))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelEdicionLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jSeparator1)
                .addContainerGap())
        );
        jPanelEdicionLayout.setVerticalGroup(
            jPanelEdicionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelEdicionLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jTextFieldNombreTrabajo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanelEdicionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonGuardarModificacion)
                    .addComponent(jButtonCancelar)
                    .addComponent(jButtonDelete))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(75, 75, 75)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jComboBoxTrabajos, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jPanelEdicion, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jComboBoxTrabajos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanelEdicion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBoxTrabajosActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxTrabajosActionPerformed
        //selecciono un trabajo de la lista y se lo paso al jText para poder editarlo o eliminarlo
        nombreTrabajo = jComboBoxTrabajos.getItemAt(jComboBoxTrabajos.getSelectedIndex());        
        jTextFieldNombreTrabajo.setText(nombreTrabajo);     
        jPanelEdicion.setVisible(true);
        this.setSize(366, 194);//diemnsiones de la ventana principal
    }//GEN-LAST:event_jComboBoxTrabajosActionPerformed

    private void jButtonGuardarModificacionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonGuardarModificacionActionPerformed
        String nombreTrabajoJCombo = jComboBoxTrabajos.getItemAt(jComboBoxTrabajos.getSelectedIndex());
        nombreTrabajo = jTextFieldNombreTrabajo.getText();
        trabajo = new TrabajoClass(nombreTrabajo);  
        util.deleteTrabajo(nombreTrabajoJCombo);
        util.modifiTrabajo(trabajo);   
        clearTexts();
    }//GEN-LAST:event_jButtonGuardarModificacionActionPerformed

    private void jButtonDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonDeleteActionPerformed
        //0=SI - 1=NO 
        nombreTrabajo = jComboBoxTrabajos.getItemAt(jComboBoxTrabajos.getSelectedIndex());
        String mensaje = "¿Realmente quieres eliminar "+nombreTrabajo+" como puesto de trabajo seleccionable?";
        int respuesta = JOptionPane.showConfirmDialog(null, mensaje, "Confirmación", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
        if(respuesta==0){
            util = new UtilClass();  
            util.deleteTrabajo(nombreTrabajo);  
            clearTexts();  
            try {
                this.setClosed(true);            
            } catch (PropertyVetoException ex) {
                Logger.getLogger(WindowNewEmpleado.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }//GEN-LAST:event_jButtonDeleteActionPerformed

    private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelarActionPerformed
        try {
            this.setClosed(true);            
        } catch (PropertyVetoException ex) {
            Logger.getLogger(WindowNewEmpleado.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonCancelarActionPerformed

    /**
     * Método que limpiara el jText
     */
    public void clearTexts(){
        jTextFieldNombreTrabajo.setText("");
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancelar;
    private javax.swing.JButton jButtonDelete;
    private javax.swing.JButton jButtonGuardarModificacion;
    private javax.swing.JComboBox<String> jComboBoxTrabajos;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanelEdicion;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTextField jTextFieldNombreTrabajo;
    // End of variables declaration//GEN-END:variables
}
